All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
viennacl::implicit_vector_base< NumericT > Class Template Reference

Common base class for representing vectors where the entries are not all stored explicitly. More...

`#include <vector_def.hpp>`

Inheritance diagram for viennacl::implicit_vector_base< NumericT >:

## Public Types

typedef NumericT const & | const_reference
typedef NumericT | cpu_value_type

## Public Member Functions

viennacl::context | context () const
vcl_size_t | size () const
cpu_value_type | value () const
vcl_size_t | index () const
bool | has_index () const
cpu_value_type | operator() (vcl_size_t i) const
cpu_value_type | operator[] (vcl_size_t i) const

## Protected Member Functions

| implicit_vector_base (vcl_size_t s, vcl_size_t i, NumericT v, viennacl::context ctx)
| implicit_vector_base (vcl_size_t s, NumericT v, viennacl::context ctx)

## Protected Attributes

vcl_size_t | size_
std::pair< bool, vcl_size_t > | index_
NumericT | value_
viennacl::context | ctx_

## Detailed Description

### template<typename NumericT>
class viennacl::implicit_vector_base< NumericT >

Common base class for representing vectors where the entries are not all stored explicitly.

Typical examples are zero_vector or scalar_vector.

Definition at line 36 of file vector_def.hpp.

## Member Typedef Documentation

template<typename NumericT>

typedef NumericT const& viennacl::implicit_vector_base< NumericT >::const_reference

Definition at line 43 of file vector_def.hpp.

template<typename NumericT>

typedef NumericT viennacl::implicit_vector_base< NumericT >::cpu_value_type

Definition at line 44 of file vector_def.hpp.

## Constructor & Destructor Documentation

template<typename NumericT>

viennacl::implicit_vector_base< NumericT >::implicit_vector_base | ( | vcl_size_t | s,
|  | vcl_size_t | i,
|  | NumericT | v,
|  | viennacl::context | ctx
| ) |  |

inline protected

Definition at line 39 of file vector_def.hpp.

template<typename NumericT>

viennacl::implicit_vector_base< NumericT >::implicit_vector_base | ( | vcl_size_t | s,
|  | NumericT | v,
|  | viennacl::context | ctx
| ) |  |

inline protected

Definition at line 40 of file vector_def.hpp.

## Member Function Documentation

template<typename NumericT>

viennacl::context viennacl::implicit_vector_base< NumericT >::context | ( |  | ) | const

inline

Definition at line 46 of file vector_def.hpp.

template<typename NumericT>

bool viennacl::implicit_vector_base< NumericT >::has_index | ( |  | ) | const

inline

Definition at line 50 of file vector_def.hpp.

template<typename NumericT>

vcl_size_t viennacl::implicit_vector_base< NumericT >::index | ( |  | ) | const

inline

Definition at line 49 of file vector_def.hpp.

template<typename NumericT>

cpu_value_type viennacl::implicit_vector_base< NumericT >::operator() | ( | vcl_size_t | i | ) | const

inline

Definition at line 52 of file vector_def.hpp.

template<typename NumericT>

cpu_value_type viennacl::implicit_vector_base< NumericT >::operator[] | ( | vcl_size_t | i | ) | const

inline

Definition at line 59 of file vector_def.hpp.

template<typename NumericT>

vcl_size_t viennacl::implicit_vector_base< NumericT >::size | ( |  | ) | const

inline

Definition at line 47 of file vector_def.hpp.

template<typename NumericT>

cpu_value_type viennacl::implicit_vector_base< NumericT >::value | ( |  | ) | const

inline

Definition at line 48 of file vector_def.hpp.

## Member Data Documentation

template<typename NumericT>

viennacl::context viennacl::implicit_vector_base< NumericT >::ctx_

protected

Definition at line 71 of file vector_def.hpp.

template<typename NumericT>

std::pair<bool, vcl_size_t> viennacl::implicit_vector_base< NumericT >::index_

protected

Definition at line 69 of file vector_def.hpp.

template<typename NumericT>

vcl_size_t viennacl::implicit_vector_base< NumericT >::size_

protected

Definition at line 68 of file vector_def.hpp.

template<typename NumericT>

NumericT viennacl::implicit_vector_base< NumericT >::value_

protected

Definition at line 70 of file vector_def.hpp.

The documentation for this class was generated from the following file:

- viennacl/detail/vector_def.hpp